package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.DiscoverBanner;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/8/25.
 */
@DAO
public interface DiscoverBannerDao {

    @Nullable
    @SelectOne
    DiscoverBanner query(Connection con, long id) throws SQLException;

    @Update
    int update(Connection con, DiscoverBanner discoverBanner) throws SQLException;

    @InsertAndGenKey(value = "id")
    long insert(Connection con, DiscoverBanner discoverBanner) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY create_time DESC")
    PageQueryResult<DiscoverBanner> query(Connection con, @Nullable String title, int pageSize, int pageNo) throws SQLException;

    @UpdateWith
    @From(DiscoverBanner.class)
    @SetSentence("end_time = TO_CHAR(NOW(),'YYYYMMDDHH24MISS') ")
    @Where("begin_time is not null and end_time is null")
    int end(Connection con)throws SQLException;
}
